#!/bin/bash

##
# detectDesktop
# Outputs: "gnome", "kde", "other", or nothing if the user isn't running X.
#
# Detect which desktop the user's currently running.
function detectDesktop() {
	if [[ "$DISPLAY" = "" ]]; then
		return 1
	fi

	local LC_ALL=C
	local clients
	if ! clients=`xlsclients`; then
		# TODO: should we fall back to using ps?
		return 1
	fi

	if echo "$clients" | grep -qE '(gnome-panel|nautilus|metacity)'; then
		echo gnome
	elif echo "$clients" | grep -qE '(kicker|slicker|karamba|kwin)'; then
		echo kde
	else
		echo other
	fi
	return 1
}

detectDesktop
